{$I-}
Uses DOS;
{$IFDEF OS2}
{+G}
Const OS='OS2';
      MAXFILES=10000;
Type  Integer=LongInt;
{$ELSE}
Const OS='DOS';
      MAXFILES=800;
{$ENDIF}
Type ADR=Record
          Zone,Net,Node,Point:Word;
         End;
Type NameArray=Array [1..MAXFILES] Of String[79];
Const DefADR:ADR=(Zone:2;Net:5020;Node:0;Point:0);
      E:Array [1..8] Of String[3]=('TIC','SU','MO','TU','WE','TH','FR','SA');
Var S,S1,S2:String;
    F,F2:Text;
    F3,F4:File;
    ADDRESS:ADR;
    NETMAIL,BINKOUT:String;
    PMAIL,PFILES,PNET:Word;
    LOG,REPORT,FLAGPATH:String;
    SR:SearchRec;
    CURADR:ADR;
    DT:DateTime;
    {$IFDEF OS2}
    DW,SS:LongInt;
    {$ELSE}
    DW,SS:Word;
    {$ENDIF}
    CurTime:LongInt;
    FILES:^NameArray;
    FCNT,PCNT:Word;
    Time:LongInt;
    I,J:Word;
    PP:LongInt;
    PurgeFlag:Boolean;
    Fix:Boolean;
    MsgHead:Record
             FromName:Array [1..36] Of Char;
             ToName:Array   [1..36] Of Char;
             Subj:Array     [1..72] Of Char;
             DateTime:Array [1..20] Of Char;
             TimesRead,
             DestNode,
             OrigNode,
             Cost,
             OrigNet,
             DestNet,
             DestZone,
             OrigZone,
             DestPoint,
             OrigPoint,
             ReplyTo,
             Attribute,
             NextReply   : Word;
            End;
    FromUser:String[36];
    ToUser:String[36];
    Subj:String[72];
    Addrs:Array [1..MAXFILES] Of ADR;
    MsgNames:Array [1..MAXFILES] Of String[12];
    Count:Integer;
    StartPurge:Boolean;

Procedure TrimSpaces(Var S:String);
Begin
 While (S[1]=' ')and(Length(S)>0) do Delete(S,1,1);
End;

Procedure NoTABS(Var S:String);
Var SS:String;
    I:Byte;
    Flag:Boolean;
Begin
 Flag:=False;
 SS:='';
 For I:=1 to Length(S) do
  If (S[I] in [#0..#32]) then Flag:=True else Begin
   If Flag then SS:=SS+' ';
   SS:=SS+S[I];
   Flag:=False;
  End;
 If SS[Length(SS)]=' ' then Delete(SS,Length(S),1);
 S:=SS
End;

Function UpcaseStr(S:String):String;
Var I:Byte;
Begin
 For I:=1 to Length(S) do S[I]:=Upcase(S[I]);
 UpcaseStr:=S
End;

Procedure NoComments(Var S:String);
Begin
 If Pos(';',S)<>0 then S:=Copy(S,1,Pos(';',S)-1);
End;

Function Str(W:LongInt):String;
Var S:String;
Begin
 System.Str(W,S);
 Str:=S;
End;

Function Val(S:String;DEF:Word):Word;
Var
{$IFDEF OS2}
   Code:LongInt;
{$ELSE}
   Code:Integer;
{$ENDIF}
W:Word;
Begin
 System.Val(S,W,Code);
 If Code<>0 then Val:=DEF else Val:=W;
End;

Function FirstWord(S:String):String;
Begin
 If Pos(' ',S)<>0 then FirstWord:=Copy(S,1,Pos(' ',S)-1) else FirstWord:=S
End;

Function SecondWord(S:String):String;
Begin
 If Pos(' ',S)<>0 then SecondWord:=Copy(S,Pos(' ',S)+1,255) else SecondWord:='';
End;

Procedure GetAdr(S:String;Def:ADR;Var A:ADR);
Const H:String[4]=':/. ';
Var
{$IFDEF OS2}
   Code:LongInt;
{$ELSE}
   Code:Integer;
{$ENDIF}
      I,J:Byte;
    AA:Array [1..4] Of Word Absolute A;
    DD:Array [1..4] Of Word Absolute Def;
Begin
 TrimSpaces(S);
 S:=S+' ';
 For I:=1 to 4 do Begin
  J:=Pos(H[I],S);
  If (I=3)and(J=0) then J:=Pos(' ',S);
  If (J<>0) or (I=3) then Begin
   System.Val(Copy(S,1,J-1),AA[I],Code);
   Delete(S,1,J);
  end else AA[I]:=DD[I];
 End;
End;

Function ADRSTR(A:ADR):String;
Begin
 With A do ADRSTR:=Str(Zone)+':'+Str(Net)+'/'+Str(Node)+'.'+Str(Point);
End;

Function HDec(S:String):Word;
Var I:Byte;
    W:Word;
    D:Word;
Begin
 W:=0;
 D:=1;
 For I:=Length(S) downto 1 do begin
  If (S[I] in ['0'..'9']) then W:=W+(Byte(S[I])-48)*D else
   If (S[I] in ['A'..'F']) then W:=W+(Byte(S[I])-55)*D else Begin
    W:=0;
    Break;
   End;
  D:=D shl 4;
 End;
 HDec:=W
End;

Function TDec(S:String):Word;
Var I:Byte;
    W:Word;
    D:Word;
Begin
 W:=0;
 D:=1;
 For I:=Length(S) downto 1 do begin
  If (S[I] in ['0'..'9']) then W:=W+(Byte(S[I])-48)*D else
   If (S[I] in ['A'..'W']) then W:=W+(Byte(S[I])-55)*D else Begin
    W:=0;
    Break;
   End;
  D:=D shl 5;
 End;
 TDec:=W
End;

Procedure Purge(A:ADR;S:String;MsgDel:Boolean);
Var FName:String[20];
    Area:String[20];
    Desc:String[50];
Begin
 PurgeFlag:=True;
 If StartPurge then Begin
  Write(#13);
  StartPurge:=False;
  Writeln(F2);
  Writeln(F2,ADRSTR(A));
  Writeln(F2,'--------------------------------------------------------------------');
 End;
 If Copy(FILES^[I],Length(FILES^[I])-3,4)='.TIC' then Begin
  While Not EOF(F) do Begin
   Readln(F,S);
   If Copy(S,1,Pos(' ',S)-1)='File' then FNAME:=Copy(S,Pos(' ',S)+1,255);
   If Copy(S,1,Pos(' ',S)-1)='Area' then AREA:=Copy(S,Pos(' ',S)+1,255);
   If Copy(S,1,Pos(' ',S)-1)='Desc' then DESC:=Copy(S,Pos(' ',S)+1,255);
  End;
  While Length(AREA)<14 do AREA:=AREA+' ';
  For J:=1 to FCNT do If Pos(FNAME,FILES^[J])<>0 then Begin
   While Length(FNAME)<12 do FNAME:=FNAME+' ';
   If MsgDel then Writeln(F2,AREA,': ',FNAME,' ',DESC,' (',MsgNames[I],')')
             else Writeln(F2,AREA,': ',FNAME,' ',DESC);
   FILES^[J]:='';
   Break;
  End;
 End else Begin
  If MsgDel then Writeln(F2,FILES^[I],' (',MsgNames[I],')')
            else Writeln(F2,FILES^[I]);
 End;
 If Fix and (FILES^[I,1]='^') then Begin
  Close(F);
  Erase(F)
 End;
 If Fix And (FILES^[I,1]='#') then Begin
  Rewrite(F);
 End;
 If Fix then Begin
  Assign(F4,Netmail+MsgNames[I]);
  Erase(F4);
 End;
 FILES^[I]:='';
End;

Procedure CheckList(A:ADR;LNAME:String);
Begin
 Assign(F,LNAME);
 Reset(F);
 IF IOREsult<>0 then Begin
  Writeln(#13,' Error opening list ',S);
  Exit;
 End;
 FCNT:=0;
 While Not EOF(F) do Begin
  If FCNT=MAXFILES then Begin
   Writeln(#13,'Node ',ADRSTR(A),' - skipped (more than ',MAXFILES,' files)');
   Exit;
  End;
  Readln(F,S);
  inc(FCNT);
  FILES^[FCNT]:=S;
 End;
 {Writeln(#13,'Found ',FCNT,' files');}
 Close(F);
 If FCNT<>0 then Begin
  StartPurge:=True;
  {Writeln('Scanning files ...');}
  For I:=1 to FCNT do Begin
   If (FILES^[I,1]='^')or(FILES^[I,1]='#') then Assign(F,Copy(FILES^[I],2,255))
                                           else Assign(F,FILES^[I]);
   Reset(F);
   If IOResult<>0 then
    Writeln(#13,' Error opening file ',FILES^[I],' for ',ADRSTR(A))
   else begin
    For J:=1 to 8 do If Copy(FILES^[I],Length(FILES^[I])-2,Length(E[J]))=E[J] then Begin
     GetFTime(F,Time);
     If Copy(FILES^[I],Length(FILES^[I])-3,4)='.TIC' then PP:=PFiles else PP:=PMail;
     If (PP<>0)and(ABS(CurTime-Time)>PP*65536) then Begin
      Purge(A,FILES^[I],False);
     End;
     Break;
    End;
    Close(F);
    If IOResult<>0 then ;
   end;
  End;
  PCNT:=0;
  For I:=1 to FCNT do Begin
   If FILES^[I]='' then Inc(PCNT);
  End;
  IF PCNT<>0 then Begin
   If Fix then Begin
    Assign(F,LNAME);
    Rewrite(F);
    For I:=1 to FCNT do If FILES^[I]<>'' then Writeln(F,FILES^[I]);
    Close(F);
    If PCNT=FCNT then Erase(F);
   End;
   Writeln(#13,'Node ',ADRSTR(A),' - ',PCNT,' files purged');
  End;
 End;
End;

Procedure GoNodes(A:ADR;S:String);
Var SR:SearchRec;
Begin
FindFirst(S+'*.*',Directory+Archive,SR);
While DOSError=0 do Begin
 If SR.NAME[1]<>'.' then Begin
  If Length(SR.NAME)=12 then Begin
   If (Copy(SR.NAME,10,3)='PNT')and(SR.Attr and Directory<>0) then Begin
    A.Net:=HDec(Copy(SR.NAME,1,4));
    A.Node:=HDec(Copy(SR.NAME,5,4));
    GoNodes(A,S+SR.NAME+'\');
   End;
   If (Copy(SR.NAME,11,2)='LO')and(SR.Attr and Directory=0) then Begin
    A.Point:=HDec(Copy(SR.NAME,1,4));
    If A.Point<>0 then Begin
     A.Net:=HDec(Copy(SR.NAME,1,4));
     A.Node:=HDec(Copy(SR.NAME,5,4));
     A.Point:=0;
    End else A.Point:=HDec(Copy(SR.NAME,5,4));
    Write(#13,'Node ',ADRSTR(A),' (',SR.NAME[10],')      ');
    Assign(F,S+Copy(SR.NAME,1,Pos('.',SR.NAME))+'BSY');
    Reset(F);
    If IOResult<>0 then CheckList(A,S+SR.NAME) else Begin
     Close(F);
     Writeln(#13,#10,' Detected busy flag for ',ADRSTR(A));
    End;

   End;
  End;
 End;
 FindNext(SR);
End;
End;

Begin
 FileMode:=0;
 Writeln('BinkPurge v0.8/',OS,'               (C)1996 Alex Matveev (2:5020/968)');
 Writeln;
 If ParamCount=0 then Begin
  Writeln('Usage: BPURGE <Command>');
  Writeln(' Commands:');
  Writeln('  REPORT - Only Scan outbound and report files whish must be purged');
  Writeln('  PURGE  - Scan outbound and purge files');
  Halt(0);
 End else If UpcaseStr(ParamStr(1))='PURGE' then Fix:=True else Fix:=False;
 S:=FSearch('BPURGE.CTL',GetEnv('PATH'));
 If S='' then S:='BPURGE.CTL';
 Assign(F,S);
 Reset(F);
 If IOResult<>0 then Begin
  Writeln(' BPURGE.CTL was not found');
  Halt(1);
 End;
 While Not EOF(F) do Begin
  Readln(F,S);
  TrimSpaces(S);
  NoComments(S);
  NOTABS(S);
  S1:=UpcaseStr(FirstWord(S));
  S2:=SecondWord(S);
  If S1='ADDRESS' then GetADR(S2,DEFADR,ADDRESS);
  If S1='BINK_OUTBOUND'  then BINKOUT:=S2;
  If S1='NETMAIL'        then NETMAIL:=S2;
  If S1='PURGE_ECHOMAIL' then PMAIL:=Val(S2,0);
  If S1='PURGE_TICFILES' then PFILES:=Val(S2,0);
  If S1='PURGE_NETMAIL'  then PNET:=Val(S2,0);
  If S1='LOG'            then LOG:=S2;
  If S1='REPORT'         then REPORT:=S2;
  If S1='FLAG'           then FLAGPATH:=S2;
 End;
 Close(F);
 {Writeln('Address : ',ADRSTR(ADDRESS));
 Writeln('Outbound: ',BINKOUT);
 Writeln('Purging Options:');
 Writeln(' Mail   : ',PMAIL);
 Writeln(' Files  : ',PFILES);
 Writeln('Log     : ',LOG);
 Writeln('Report  : ',REPORT);}
 Assign(F2,REPORT);
 Rewrite(F2);
 With CURADR do Begin
  ZONE:=0;
  Net:=0;
  Node:=0;
  Point:=0;
 End;
 With DT Do GetDate(Year,Month,Day,DW);
 With DT Do GetTime(Hour,Min,Sec,SS);
 PackTime(DT,CurTime); {65536 per day}
 New(FILES);
 PurgeFlag:=False;
 If Netmail<>'' then Begin
  Writeln('Scanning Netmail at ',Netmail,'*.MSG ...');
  FindFirst(Netmail+'*.MSG',Archive,SR);
  FCNT:=0;
  While DOSError=0 do Begin
   Assign(F3,Netmail+SR.NAME);
   Reset(F3,1);
   If IOResult<>0 then
    Writeln(' Can''t open ',Netmail+SR.Name)
   else Begin
    BlockRead(F3,MsgHead,SizeOf(MsgHead));
    If IOResult<>0 then
     Writeln(' Can''t read header of ',SR.NAME)
    else Begin
     For I:=1 to 36 do If MsgHead.FromName[I]<>#0 then FromUser[I]:=MsgHead.FromName[I] else Break;FromUser[0]:=Chr(I-1);
     For I:=1 to 36 do If MsgHead.ToName[I]<>#0 then ToUser[I]:=MsgHead.ToName[I] else Break;ToUser[0]:=Chr(I-1);
     For I:=1 to 72 do If MsgHead.Subj[I]<>#0 then Subj[I]:=MsgHead.Subj[I] else Break;Subj[0]:=Chr(I-1);
     If MsgHead.Attribute and $10<>0 then Begin
      If FCNT=MAXFILES then Begin
       Writeln(' Sorry can''t handle more than ',MAXFILES,' file-attach messages)');
       Writeln(' Hint: It''s fine time to start using BinkOutBound :)');
       Exit;
      End;
      BlockRead(F3,S[1],255,Count);
      S[0]:=Chr(Count);
      inc(FCNT);
      ADDRS[FCNT].Zone:=Address.Zone;
      ADDRS[FCNT].Net:=MsgHead.DestNet;
      ADDRS[FCNT].Node:=MsgHead.DestNode;
      ADDRS[FCNT].Point:=MsgHead.DestPoint;
      FILES^[FCNT]:=Subj;
      MsgNames[FCNT]:=SR.NAME;
      S1:=S;
      I:=Pos(#1'INTL',S);
      If I<>0 then Begin
       Delete(S,1,I+5);
       I:=Pos(#13,S);
       Delete(S,I,255);
       GetADR(FirstWord(S),Address,ADDRS[FCNT]);
      End;
      S:=S1;
      I:=Pos(#1'TOPT',S);
      If I<>0 then Begin
       Delete(S,1,I+5);
       I:=Pos(#13,S);
       Delete(S,I,255);
       ADDRS[FCNT].Point:=Val(S,0);
      End;
      S:=S1;
      I:=Pos(#1'FLAGS',S);
      If I<>0 then Begin
       Delete(S,1,I+6);
       I:=Pos(#13,S);
       Delete(S,I,255);
       If Pos('KFS',S)<>0 then Files^[FCNT]:='^'+Files^[FCNT] else
       If Pos('TFS',S)<>0 then Files^[FCNT]:='#'+Files^[FCNT];
      End;
     End;
    Close(F3);
    End;
   End;
   FindNext(SR);
  End;
 If FCNT<>0 then Begin
  For I:=1 to FCNT do Begin
   If (FILES^[I,1]='^')or(FILES^[I,1]='#') then Assign(F,Copy(FILES^[I],2,255))
                                           else Assign(F,FILES^[I]);
   Reset(F);
   If IOResult<>0 then
    Writeln(#13,' Error opening file ',FILES^[I],' for ',ADRSTR(ADDRS[I]))
   else begin
    For J:=1 to 8 do If Copy(FILES^[I],Length(FILES^[I])-2,Length(E[J]))=E[J] then Begin
     GetFTime(F,Time);
     If Copy(FILES^[I],Length(FILES^[I])-3,4)='.TIC' then PP:=PFiles else PP:=PMail;
     If ABS(CurTime-Time)>PP*65536 then Begin
      StartPurge:=True;
      Purge(ADDRS[I],FILES^[I],True);
     End;
     Break;
    End;
    Close(F);
    If IOResult<>0 then ;
   end;
  End;
  PCNT:=0;
  For I:=1 to FCNT do Begin
   If FILES^[I]='' then Inc(PCNT);
  End;
  IF PCNT<>0 then Begin
   Writeln(PCNT,' files purged');
  End;
 End;
 End;

 If BinkOut<>'' then Begin
  FCNT:=0;
  Writeln('Scanning Bink Outbound at ',BinkOut,'.* ...');
  FindFirst(BinkOut+'.*',Directory,SR);
  While DOSError=0 do Begin
   If SR.NAME[1]<>'.' then Begin
    If Pos('.',SR.NAME)=0 then CURADR.Zone:=ADDRESS.Zone else CurADR.Zone:=HDec(Copy(SR.NAME,Pos('.',SR.NAME)+1,3));
     {Writeln;
     Writeln('Zone: ',CURADR.ZONE:3);}
     S:=BinkOut;
     While S[Length(S)]<>'\' do Delete(S,Length(S),1);
     GoNodes(CurADR,S+SR.NAME+'\');
    End;
    FindNext(SR);
   End;
  Writeln(#13,'                                ');
 End;
 Dispose(FILES);
 Close(F2);
 If Not PurgeFlag then Begin
  Erase(F2);
  Writeln('Nothing to purge');
 End else If Fix then Begin
  Assign(F4,FlagPath);
  Rewrite(F4);
  Close(F4);
 End;
End.
